#encoding: UTF-8
require 'pdf-reader'
require 'digest'

module PdfSearch
  class PdfDir
		def initialize(dir = '.')
			@dir = dir
		end

		def pdf_file_paths
			Dir.glob(File.join(File.expand_path(@dir), '*.pdf'))
		end

		def pdf_documents
			Enumerator.new do |e|
        pdf_file_paths.each do |pdf_file_path|
          e << PDF::Reader.new(pdf_file_path)
        end
			end
		end

		def pages
			Enumerator.new do |e|
				pdf_documents.each do |pdf_reader|
					pdf_reader.pages.each do |page|
						e << [page, pdf_reader, Digest::SHA256.hexdigest(Marshal.dump(pdf_reader.info))]
					end
				end
			end
		end
  end
end
