require 'elastic_search_query'
require 'pdf_index'
require 'daemons'
require 'search_view'
require 'pdf_dir'
require 'elasticsearch'
require 'web_server'

module PdfSearch
	ElasticSearchClient = Elasticsearch::Client.new log: true, host: ENV['ELASTICSEARCH_URL']

  GemDir = [File.dirname(__FILE__), '..']

  def self.relative_to_gem_path(path_array)
    File.expand_path(File.join(GemDir + path_array))
  end

  def self.start_webserver(search_index)
    web_server = WebServer.new(search_index)
    web_server.start
    return web_server.daemon.pid.pid
  end

	def self.start_elasticsearch
		`sudo service elasticsearch start`
	end

	def self.create_elasticsearch_index
    PdfIndex.create_index
	end

  def self.wrap_elastic_request
		`curl -XPUT -H "Content-Type: application/json" http://localhost:9200/_all/_settings -d '{"index.blocks.read_only_allow_delete": null}'`
    yield
  end
end
